package fr.ynerant.tarot.ui.stats;

import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProviders;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Executors;

import fr.ynerant.tarot.Game;
import fr.ynerant.tarot.MainActivity;
import fr.ynerant.tarot.Player;
import fr.ynerant.tarot.R;
import fr.ynerant.tarot.ui.home.HomeFragment;

public class PersonalStatsFragment extends Fragment {

	private PersonalStatsModel personalStatsModel;

	public View onCreateView(@NonNull LayoutInflater inflater,
							 ViewGroup container, final Bundle savedInstanceState) {
		personalStatsModel =
				ViewModelProviders.of(this).get(PersonalStatsModel.class);
		final View root = inflater.inflate(R.layout.fragment_personal_stats, container, false);

		if (PreferenceManager.getDefaultSharedPreferences(MainActivity.INSTANCE).getString("token", null) == null) {
			//noinspection ConstantConditions
			getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, new HomeFragment(), "Se connecter").commit();
			return root;
		}

		//noinspection ConstantConditions
		Player player = Player.getPlayerById(getArguments().getInt("playerId"));

		TextView points3 = root.findViewById(R.id.points3);
		TextView points4 = root.findViewById(R.id.points4);
		TextView points5 = root.findViewById(R.id.points5);
		TextView points6 = root.findViewById(R.id.points6);

		points3.setText(String.valueOf(player.getScore(Game.GameType.THREE_PLAYERS)));
		points4.setText(String.valueOf(player.getScore(Game.GameType.FOUR_PLAYERS)));
		points5.setText(String.valueOf(player.getScore(Game.GameType.FIVE_PLAYERS)));
		points6.setText(String.valueOf(player.getScore(Game.GameType.SIX_PLAYERS)));

		return root;
	}
}