package fr.ynerant.tarot.ui.stats;

import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProviders;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Executors;

import fr.ynerant.tarot.Game;
import fr.ynerant.tarot.MainActivity;
import fr.ynerant.tarot.Player;
import fr.ynerant.tarot.R;
import fr.ynerant.tarot.ui.home.HomeFragment;

public class PersonalStatsMenuFragment extends Fragment {

	private PersonalStatsMenuModel personalStatsMenuModel;

	public View onCreateView(@NonNull LayoutInflater inflater,
							 ViewGroup container, final Bundle savedInstanceState) {
		personalStatsMenuModel =
				ViewModelProviders.of(this).get(PersonalStatsMenuModel.class);
		final View root = inflater.inflate(R.layout.fragment_personal_stats_menu, container, false);

		if (PreferenceManager.getDefaultSharedPreferences(MainActivity.INSTANCE).getString("token", null) == null) {
			//noinspection ConstantConditions
			getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, new HomeFragment(), "Se connecter").commit();
			return root;
		}

		ListView players = root.findViewById(R.id.players_stats);
		//noinspection ConstantConditions
		final ListAdapter adapter = new ArrayAdapter<>(getContext(), android.R.layout.simple_expandable_list_item_1, new ArrayList<>(Player.getAllPlayers()));
		players.setAdapter(adapter);

		players.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				Player player = (Player) adapter.getItem(position);
				PersonalStatsFragment fragment = new PersonalStatsFragment();
				Bundle bundle = new Bundle();
				bundle.putInt("playerId", player.getId());
				fragment.setArguments(bundle);
				//noinspection ConstantConditions
				getFragmentManager().beginTransaction().replace(R.id.nav_host_fragment, fragment, "Statistiques individuelles de " + player.getName())
						.addToBackStack("Statistiques individuelles").commit();
			}
		});

		return root;
	}
}